
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Job_checklist_run_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const job_checklist_run_items = await db.job_checklist_run_items.create(
            {
                id: data.id || undefined,
        
        state: data.state
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
        completed_at: data.completed_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await job_checklist_run_items.setWorkspace( data.workspace || null, {
            transaction,
        });
        
        await job_checklist_run_items.setJob_checklist_run( data.job_checklist_run || null, {
            transaction,
        });
        
        await job_checklist_run_items.setChecklist_item( data.checklist_item || null, {
            transaction,
        });
        
        await job_checklist_run_items.setCompleted_by( data.completed_by || null, {
            transaction,
        });
        
        await job_checklist_run_items.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return job_checklist_run_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const job_checklist_run_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                state: item.state
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
                completed_at: item.completed_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const job_checklist_run_items = await db.job_checklist_run_items.bulkCreate(job_checklist_run_itemsData, { transaction });

        // For each item created, replace relation files
        

        return job_checklist_run_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const job_checklist_run_items = await db.job_checklist_run_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.state !== undefined) updatePayload.state = data.state;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        if (data.completed_at !== undefined) updatePayload.completed_at = data.completed_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await job_checklist_run_items.update(updatePayload, {transaction});

        
        
        if (data.workspace !== undefined) {
            await job_checklist_run_items.setWorkspace(
              
              data.workspace,
              
              { transaction }
            );
        }
        
        if (data.job_checklist_run !== undefined) {
            await job_checklist_run_items.setJob_checklist_run(
              
              data.job_checklist_run,
              
              { transaction }
            );
        }
        
        if (data.checklist_item !== undefined) {
            await job_checklist_run_items.setChecklist_item(
              
              data.checklist_item,
              
              { transaction }
            );
        }
        
        if (data.completed_by !== undefined) {
            await job_checklist_run_items.setCompleted_by(
              
              data.completed_by,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await job_checklist_run_items.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return job_checklist_run_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const job_checklist_run_items = await db.job_checklist_run_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of job_checklist_run_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of job_checklist_run_items) {
                await record.destroy({transaction});
            }
        });


        return job_checklist_run_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const job_checklist_run_items = await db.job_checklist_run_items.findByPk(id, options);

        await job_checklist_run_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await job_checklist_run_items.destroy({
            transaction
        });

        return job_checklist_run_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const job_checklist_run_items = await db.job_checklist_run_items.findOne(
            { where },
            { transaction },
        );

        if (!job_checklist_run_items) {
            return job_checklist_run_items;
        }

        const output = job_checklist_run_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.workspace = await job_checklist_run_items.getWorkspace({
            transaction
        });
        
        
        output.job_checklist_run = await job_checklist_run_items.getJob_checklist_run({
            transaction
        });
        
        
        output.checklist_item = await job_checklist_run_items.getChecklist_item({
            transaction
        });
        
        
        output.completed_by = await job_checklist_run_items.getCompleted_by({
            transaction
        });
        
        
        output.organizations = await job_checklist_run_items.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.workspaces,
        as: 'workspace',
        
        where: filter.workspace ? {
          [Op.or]: [
            { id: { [Op.in]: filter.workspace.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.workspace.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.job_checklist_runs,
        as: 'job_checklist_run',
        
        where: filter.job_checklist_run ? {
          [Op.or]: [
            { id: { [Op.in]: filter.job_checklist_run.split('|').map(term => Utils.uuid(term)) } },
            {
              status: {
                [Op.or]: filter.job_checklist_run.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.checklist_items,
        as: 'checklist_item',
        
        where: filter.checklist_item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.checklist_item.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.checklist_item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'completed_by',
        
        where: filter.completed_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.completed_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.completed_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'job_checklist_run_items',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.completed_atRange) {
                const [start, end] = filter.completed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    completed_at: {
                    ...where.completed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    completed_at: {
                    ...where.completed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.state) {
                where = {
                    ...where,
                state: filter.state,
            };
            }
            


      

      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.job_checklist_run_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'job_checklist_run_items',
                        'state',
                        query,
                    ),
                ],
            };
        }

        const records = await db.job_checklist_run_items.findAll({
            attributes: [ 'id', 'state' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['state', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.state,
        }));
    }

    
};

